using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;
namespace Dat2Bin
{
    public class LinkList
    {
        /// <summary>
        /// 
        /// </summary>
        private int _length;//ÿһɾһ
        public int Length
        {
            get { return _length; }
        }//ȵĽӿֻ
        private Node _head;//ͷ
        public Node head
        {
            get { return _head; }
        }

        private Node _end;//β
        public Node End
        {
            get { return _end; }
        }

        /// <summary>
        /// ֵindexڵ㡣
        /// </summary>
        /// <param name="index"></param>
        /// <param name="flag"></param>
        /// <returns></returns>
        private Node FindNodeByIndex(int index)
        {
            //Խ׳쳣
            //쳣УΪ0indexΪ0ҲΪ쳣index<0ΪԽ硣
            if (_length <= index || index < 0) throw new IndexOutOfRangeException("ޡ");
            Node flag = null;
            int hcount = index;//ͷĿ
            int ecount = _length - index - 1;//βĿ
            //ͷҵĿСڵڴβҵĿʹͷʼ顣
            if (hcount <= ecount)
            {
                flag = _head;
                int count = hcount;//ؼһΪ˫
                //ʼƶǣֱƵҪҵĽڵλ
                while (count > 0)
                {
                    flag = flag.Next;
                    count--;
                }
            }
            else
            {
                flag = _end;
                int count = ecount;//ؼһΪ˫
                //ʼƶǣֱƵҪҵĽڵλ
                while (count > 0)
                {
                    flag = flag.Pre;
                    count--;
                }
            }
            //ʱflagλñ
            return flag;
        }
        public LinkList()
        {
            //½һ,Ϊ0
            _head = null;
            _end = null;
            _length = 0;
        }

        /// <summary>
        /// T͵dataװλ
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        public void Add(string fileName, string SafeFileName, DateTime fileStartTime, DateTime fileEndTime, HEADInfo file_head)
        {
            //½һڵ
            Node newNode = new Node();
            newNode.Next = null;//ΪβnextָضΪ

            newNode.data.fileName = fileName;
            newNode.data.SafeFileName = SafeFileName;
            newNode.data.fileStartTime = fileStartTime;
            newNode.data.fileEndTime = fileEndTime;
            newNode.data.fileHead = file_head;


            if (_head == null)           //ͷڵΪգΪգ
            {
                _head = newNode;          //_headֱָ½Ľڵ㡣
                _head.Pre = null;       //½ĽڵǰΪnull

            }
            else
            {
                _end.Next = newNode;
                newNode.Pre = _end;       //һ֡

            }
            _end = newNode;             //λΪβ
            _length++;                   //ȼһ
        }
        public void Add(string fileName, string SafeFileName, DateTime fileStartTime, DateTime fileEndTime, HEADInfo file_head, byte transtimeOK)
        {
            //½һڵ
            Node newNode = new Node();
            newNode.Next = null;//ΪβnextָضΪ

            newNode.data.fileName = fileName;
            newNode.data.SafeFileName = SafeFileName;
            newNode.data.fileStartTime = fileStartTime;
            newNode.data.fileEndTime = fileEndTime;
            newNode.data.fileHead = file_head;
            newNode.data.transtimeOK = transtimeOK;

            if (_head == null)           //ͷڵΪգΪգ
            {
                _head = newNode;          //_headֱָ½Ľڵ㡣
                _head.Pre = null;       //½ĽڵǰΪnull

            }
            else
            {
                _end.Next = newNode;
                newNode.Pre = _end;       //һ֡

            }
            _end = newNode;             //λΪβ
            _length++;                   //ȼһ
        }

        /// <summary>
        /// T͵dataװλ
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        public void Add(SiteParameter data)
        {
            //½һڵ
            Node newNode = new Node();
            newNode.Next = null;//ΪβnextָضΪ
            newNode.data = data;
            if (_head == null)           //ͷڵΪգΪգ
            {
                _head = newNode;          //_headֱָ½Ľڵ㡣
                _head.Pre = null;       //½ĽڵǰΪnull

            }
            else
            {
                _end.Next = newNode;
                newNode.Pre = _end;       //һ֡

            }
            _end = newNode;             //λΪβ
            _length++;                   //ȼһ
        }


        /// <summary>
        /// ƳָλõԪ
        /// </summary>
        /// <param name="index"></param>
        public void RemoveAt(int index)
        {
            //ԽexceptionѾFindNodeByIndexдˡ
            Node flag = FindNodeByIndex(index);
            //flagѾҪɾĽڵ㴦

            if (_head.Next == null)//ֻһڵ㣬indexûԽ缴ɾ_head
            {
                //ֱӸ
                _head = null;
                _end = null;
                //öΪ flag.Next.Pre = flag.Pre;
                //_head.NextΪվͲPreָ
            }
            else//жһĽڵ,indexûԽ,ͼֿͳһ
            {
                //ɾڵ
                if (index == _length - 1) _end = _end.Pre;
                else flag.Next.Pre = flag.Pre;
                if (index == 0) _head = flag.Next;
                else flag.Pre.Next = flag.Next;
            }
            _length--;//ǿҳûԽ磬ʳɾ֮󣬱Ȼһ
            //һֶΣͱҪһԡ
        }
        public SiteParameter GetnodeData(int position)
        {
            Node flag = FindNodeByIndex(position - 1);//1ʼ
            return flag.data;

        }
        public void SetNodeData(int position, ref SiteParameter data)
        {
            Node flag = FindNodeByIndex(position - 1);//1ʼ
            flag.data = data;
        }

        /// <summary>
        /// SiteParameterߵֵ
        /// </summary>
        /// <param name="index"></param>
        /// <returns></returns>
        public SiteParameter this[int index]
        {
            get
            {
                Node flag = FindNodeByIndex(index);
                return flag.data;
            }
            set
            {
                Node flag = FindNodeByIndex(index);
                flag.data = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public void Clear()
        {
            _head = null;
            _end = null;
            _length = 0;
        }

        /// <summary>
        /// ȡԪصĸ
        /// </summary>
        public int GetLength()
        {
            return _length;
        }
    }
}
